var plask = require('plask');
var fs = require('fs');

eval(fs.readFileSync('../src/timeline.js', 'utf-8'));

plask.simpleWindow({
  settings: {
    width: 1280,
    height: 720,
    type: '2d'
  },
  agents: [],
  init: function() {
    this.framerate(30);
    anim(this.agent)
      .to({x: 400}, 1, Timeline.Easing.Quadratic.EaseOut)
      .to({y: 400}, 1, Timeline.Easing.Quadratic.EaseIn)
      .to({x: 50, y: 50}, 1, Timeline.Easing.Bounce.EaseOut)
    ;

    this.on('mouseMoved', function(e) {
      this.mouseX = e.x;
      this.mouseY = e.y;
      this.moved = true;
    });

    this.mouseX = this.width/2;
    this.mouseY = this.height/2;
  },
  prevTime: new Date().getTime()/1000,
  totalTime: 0,
  emitTime: 0,
  moved: false,
  draw: function() {
    var time = new Date().getTime()/1000;
    var deltaTime = time - this.prevTime;
    this.prevTime = time;
    Timeline.getGlobalInstance().update(deltaTime);

    if (this.moved) {
      this.emitTime += deltaTime;
      this.moved = false;
    }
    if (this.emitTime > 0.01) {
      this.emitTime = 0;

      var agent = {
        alpha: 1,
        x: this.mouseX,
        y: this.mouseY,
        width: 20,
        height: 20
      };
      anim(agent)
        .to({ alpha: 0.5, x : agent.x + Math.random() * 100 - 50, y : agent.y + Math.random() * 100 - 50}, 1, Timeline.Easing.Quadratic.EaseOut)
        .to(0, { width: 5, height: 5}, 1, Timeline.Easing.Bounce.EaseInOut)
      this.agents.push(agent);
    }

    var paint = this.paint;
    var canvas = this.canvas;

    canvas.eraseColor(255, 255, 255, 255);

    paint.setFill();

    this.agents.forEach(function(agent) {
      paint.setColor(255, 0, 0, agent.alpha * 255);
      canvas.drawRect(paint,
       agent.x - agent.width/2, agent.y - agent.height/2,
       agent.x + agent.width/2, agent.y + agent.height/2
      );
    });
  }
});