var plask = require('plask');
var fs = require('fs');

eval(fs.readFileSync('Tween.js', 'utf-8'));

plask.simpleWindow({
  settings: {
    width: 1280,
    height: 720,
    type: '2d'
  },
  agents: [],
  init: function() {
    this.framerate(30);
    this.agents = [
      { x: 0, y:this.height/2, w:50, h:50},
      { x: this.width, y:this.height/2, w:50, h:50}
    ];

    var c1 = new TWEEN.Tween(this.agents[0]).to({x:this.width/2 - 25, w:50}, 200).start();
    var c2 = new TWEEN.Tween(this.agents[1]).to({x:this.width/2 + 25, w:50}, 200).start();
    var u1 = new TWEEN.Tween(this.agents[0], false).to({x:this.width/2,y:20,w:0}, 200);
    var u2 = new TWEEN.Tween(this.agents[1], false).to({x:this.width/2,y:20,w:0}, 200);

    c1.chain(u1);
    c2.chain(u2);

    u1.chain(c1);
  },
  prevTime: new Date().getTime()/1000,
  totalTime: 0,
  emitTime: 0,
  moved: false,
  draw: function() {
    TWEEN.update();

    var paint = this.paint;
    var canvas = this.canvas;

    canvas.eraseColor(255, 255, 255, 255);

    paint.setFill();
    paint.setColor(255, 0, 0, 255);

    this.agents.forEach(function(agent) {
      paint.setColor(255, 0, 0, agent.alpha * 255);
      canvas.drawRect(paint,
       agent.x - agent.w/2, agent.y - agent.h/2,
       agent.x + agent.w/2, agent.y + agent.h/2
      );
    });
  }
});